.386
.model flat,stdcall
option casemap:none

include filefunc.inc

; Exit codes returned by ReadFileToMem

; INVALID_HANDLE_VALUE equ -1 ; CreateFile API error
  MEM_ALLOC_FAILURE    equ 0  ; memory allocation failure
  GETFILESIZE_ERROR    equ 1
  READFILE_ERROR       equ 2  ; ReadFile API error
  READFILETOMEM_OK     equ 3  ; Operation successfull

PUBLIC  ReadFileToMem@12

.code

;   ReadFileToMem PROC pFileName:DWORD,pMem:DWORD,pNumbOfBytesRead:DWORD

;       pFileName           :  pointer to name of the file
;       pMem                :  pointer receiving the memory block allocated to read the input file
;       pNumbOfBytesRead    :  pointer receiving the number of bytes read

;       Return value        :  if the function succeeds, the return value is 3 
;                              if the function fails, the return value S an error code


ReadFileToMem@12:

    sub     esp,4*4                                                 ; reserve 12 bytes for local variables

    invoke  CreateFile,DWORD PTR [esp+44],GENERIC_READ,0,0,\
            OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0                  ; open file
    cmp     eax,INVALID_HANDLE_VALUE
    je      _exitC
    push    esi
@@:
    mov     DWORD PTR [esp+16],eax
    invoke  GetFileSize,eax,0
    mov     esi,GETFILESIZE_ERROR
    cmp     eax,-1
    je      _exitB
    mov     DWORD PTR [esp+4],eax
    invoke  VirtualAlloc,0,eax,MEM_COMMIT,PAGE_READWRITE            ; allocate memory
    mov     esi,eax
    test    eax,eax
    jz      _exitB
   
@@:
    mov     DWORD PTR [esp+12],eax
    mov     edx,DWORD PTR [esp+28]
    mov     DWORD PTR [edx],eax

    lea     edx,[esp+8]
    invoke  ReadFile,DWORD PTR [esp+32],eax,DWORD PTR [esp+12],edx,0 ; read file
    mov     esi,READFILE_ERROR
    test    eax,eax
    jz      _exitA
@@:
    mov     edx,DWORD PTR [esp+32]
    mov     eax,DWORD PTR [esp+8]
    mov     DWORD PTR [edx],eax
    mov     esi,3
    jmp     _exitB

_exitA:

    invoke  VirtualFree,DWORD PTR [esp+20],0,MEM_RELEASE            ; release the allocated memory
    
_exitB:

    invoke  CloseHandle,DWORD PTR [esp+16]                          ; close file
    
    mov     eax,esi
    pop     esi

_exitC:

    add     esp,4*4                                                 ; balance the stack manually
    ret     3*4                                                     ; release the three parameters

;   ENDP ReadFileToMem

END

