include     ImportFuncFromEXE.inc

.data

FileName    db 'ExeExportFunc.exe',0
EXEfunc1    db '_ClearScreen@0',0  ; ClearScreen function from ExeExportFunc.exe
EXEfunc2    db '_StdOut@4',0       ; StdOut function from ExeExportFunc.exe

message     db 'Testing Executable exporting functions - StdOut function',0
errmessage1 db 'Application could not initialize ExeExportFunc.exe',0
errmessage2 db 'GetProcAddr cannot find the address',13,10
            db 'of the requested function',0
errmessage3 db 'ReadFileToMem error',0
caption     db 'Error',0

.data?

hVirtModule dd ?
pEXE        dd ?
pEntry      dd ?
BytesRead   dd ?

.code

start:

    invoke  ReadFileToMem,ADDR FileName,ADDR pEXE,ADDR BytesRead
    cmp     eax,3  ; Operation successfull
    je      @f

    mov     eax,OFFSET errmessage3
    invoke  DisplayMsgbox
    jmp     finish3
    
@@:
    invoke  LoadEXEfromMem,pEXE,ADDR pEntry
    test    eax,eax
    jnz     @f
    mov     eax,OFFSET errmessage1
    invoke  DisplayMsgbox
    jmp     finish2
                            
@@:
    mov     hVirtModule,eax

; GetProcAddr gets the address of ClearScreen from the "virtual" ExeExportFunc.exe

    invoke  GetProcAddr,eax,ADDR EXEfunc1
    cmp     eax,-1
    jne     @f

    mov     eax,OFFSET errmessage2
    invoke  DisplayMsgbox
    jmp     finish1

@@:

; eax -> address of ClearScreen

    _invoke eax

; GetProcAddr gets the address of StdOut from the "virtual" ExeExportFunc.exe

    invoke  GetProcAddr,hVirtModule,ADDR EXEfunc2
    cmp     eax,-1
    jne     @f
    
    mov     eax,OFFSET errmessage2
    invoke  DisplayMsgbox
    jmp     finish1
    
@@:

; eax -> address of StdOut taking one parameter

    _invoke eax,ADDR message
       
finish1:

; Release the "virtual" EXE mapped to the address space pointed by LoadEXEfromMem

    invoke  FreeEXEfromMem,hVirtModule

finish2:

; Release the EXE loaded as binary data

    invoke  FreeMemory,pEXE

finish3:

    invoke  ExitProcess,0

DisplayMsgbox PROC

    invoke  MessageBox,0,eax,ADDR caption,MB_ICONERROR
    ret

DisplayMsgbox ENDP

END start

